Attribute VB_Name = "modWaitForStartApp"
Option Explicit

'Dieser Source stammt von http://www.activevb.de
'und kann frei verwendet werden. Fr eventuelle Schden
'wird nicht gehaftet.

'Um Fehler oder Fragen zu klren, nutzen Sie bitte unser Forum.
'Ansonsten viel Spa und Erfolg mit diesem Source !

' Der Ursprungscode wurde von Georg Mhlberger geschrieben
'   (angelehnt an die MSDN Library).

Private Declare Function CreateProcess Lib "kernel32" Alias _
    "CreateProcessA" (ByVal lpApplicationName As String, _
    ByVal lpCommandLine As String, lpProcessAttributes As Any, _
    lpThreadAttributes As Any, ByVal bInheritHandles As Long, _
    ByVal dwCreationFlags As Long, lpEnvironment As Any, _
    ByVal lpCurrentDriectory As String, lpStartUpInfo As STARTUPINFO, _
    lpProcessInformation As PROCESS_INFORMATION) As Long

Private Declare Function WaitForInputIdle Lib "user32" ( _
    ByVal hProcess As Long, ByVal dwMilliseconds As Long) As Long

Private Type PROCESS_INFORMATION
   hProcess As Long
   hThread As Long
   dwProcessId As Long
   dwThreadId As Long
End Type

Private Type STARTUPINFO
   cb As Long
   lpReserved As String
   lpDesktop As String
   lpTitle As String
   dwX As Long
   dwY As Long
   dwXSize As Long
   dwYSize As Long
   dwXCountChars As Long
   dwYCountChars As Long
   dwFillAttribute As Long
   dwFlags As Long
   wShowWindow As Integer
   cbReserved2 As Integer
   lpReserved2 As Long
   hStdInput As Long
   hStdOutput As Long
   hStdError As Long
End Type

Private Const NORMAL_PRIORITY_CLASS = &H20&
Private Const STARTF_USESHOWWINDOW As Long = &H1&
Private Const INFINITE As Long = -1&
Private Const WAIT_OBJECT_0 As Long = 0
Private Const WAIT_TIMEOUT As Long = &H102&
Private Const WAIT_FAILED As Long = -1&

Public Enum wsaErrors
    wsaNoError = 0
    wsaStartError = 1
    wsaTimeOut = 2
    wsaOtherError = 3
End Enum

' Funktion WaitForStartApp
' ========================
'   Startet eine Anwendung und wartet, bis diese auf Benutzereingaben
'   reagiert, also vollstndig gestartet wurde.
'
'   Parameter:
'       o Path               Programmpfad inkl. Kommandozeilenparameter
'                              der zu startenden Anwendung.
'       o WinStyle           Gibt an, wie die Anwendung gestartet
'                              werden soll.
'       o TimeOut            Zeit die maximal gewartet werden soll
'                              bis die Funktion zurckkehrt
'       o DoEv               Gibt an ob whrend dem Anwendungsstart
'                              Ereignisse verarbeitet werden knnen
'                              (DoEvents)
'
'   Mgliche Rckgabewerte:
'       o wsaNoError    Anwendung wurde erfolgreich gestartet.
'       o wsaStartError Anwendung konnte nicht gestartet werden.
'       o wsaTimeOut    TimeOut-Zeit erreicht.
'       o wsaOtherError Sonstiger Fehler.

Public Function WaitForStartApp(Path As String, _
        Optional WinStyle As VbAppWinStyle, _
        Optional TimeOut As Long = 10000, _
        Optional DoEv As Boolean = True) As wsaErrors
        
    Dim lngRet As Long
    Dim udtSInfo As STARTUPINFO
    Dim lngWaitTime As Long
    Dim udtPInfo As PROCESS_INFORMATION
    
    ' Prozessstruktur initialisieren
    With udtSInfo
        .cb = LenB(udtSInfo)
        .dwFlags = STARTF_USESHOWWINDOW
        .wShowWindow = WinStyle
    End With

    ' Anwendung starten
    lngRet = CreateProcess(vbNullString, Path, ByVal 0&, _
        ByVal 0&, 1&, NORMAL_PRIORITY_CLASS, ByVal 0&, _
        vbNullString, udtSInfo, udtPInfo)
        
    If lngRet = 0 Then
        ' Fehler beim Starten der Anwendung aufgetreten
        WaitForStartApp = wsaStartError
        Exit Function
    End If
    
    ' Warten, bis Anwendung reagiert oder TimeOut erreicht ist
    Do
        ' Anwendung auf Reaktion prfen
        lngRet = WaitForInputIdle(udtPInfo.hProcess, 50)
        
        If lngRet = WAIT_TIMEOUT Then
            'Anwendung reagiert noch nicht
            If DoEv Then DoEvents           ' Falls erwnscht, DoEvents
            lngWaitTime = lngWaitTime + 50  ' Verstrichene Zeit erhhen
        End If
            
        
    Loop Until lngRet <> WAIT_TIMEOUT Or lngWaitTime > TimeOut
    
    ' Evtl. Fehler auswerten
    Select Case lngRet
    Case WAIT_OBJECT_0
        WaitForStartApp = wsaNoError     ' Kein Fehler
    Case WAIT_TIMEOUT
        WaitForStartApp = wsaTimeOut     ' TimeOut erreicht
    Case WAIT_FAILED
        WaitForStartApp = wsaOtherError  ' Sonstiger Fehler
    End Select
End Function

